﻿#include "hmiworks.h"
BYTE ladder_main(BYTE);
static BYTE r_out(BYTE);

int _CurrentFrame = 0;
int _tpd_tcp_inited = 0;

const char *g_FrameNames[] = 
{
  "Frame1",
  "Frame2",
};

const int g_FrameCount = (sizeof(g_FrameNames)/sizeof(char *));

#define MAGIC_NUM_TO_CON		472882027


void CheckModbus()
{
}

void _tpd_tcp_initial()
{
   if ( !lwIPLocalIPAddrGet() ) return;


   _tpd_tcp_inited = 1;
}

volatile unsigned long g_TimerTicksCount = 0;
unsigned long g_ulTickTmrEvtTrig = 0;


void hmi_TimerTrigger()
{
  g_TimerTicksCount++;
  
  if (table_init_flag && (g_TimerTicksCount%(100/10)) == 0)
  { g_ulTickTmrEvtTrig = g_TimerTicksCount;
    AddQueueMessage(0);}
  
  if ( _tpd_tcp_inited ) {
     if ((g_TimerTicksCount%50) == 0) CheckModbus();
  } else if ( g_TimerTicksCount > 80 )
     _tpd_tcp_initial();
  
  switch(_CurrentFrame) {
    case 1: {
    break;
    }
    case 2: {
     TimerUpdate(&Timer14, 10);
    break;
    }
  }
}

void FreeCurrentFrame()
{
  switch (_CurrentFrame)
  {
	case 1: FreeWidget1(); break;
	case 2: FreeWidget2(); break;
  }
}

void hmi_GetActiveFrame(char* str, unsigned int len)
{
 int FNLen = strlen(g_FrameNames[_CurrentFrame-1]);
 if(len >= FNLen)
 memcpy(str, g_FrameNames[_CurrentFrame-1], FNLen);
}

void hmi_GotoFrame(int nFrame)
{
  WidgetMessageQueueProcessEx(WIDGET_MSG_PAINT);

  switch(nFrame)
  {
	case 1: _Frame1(); break;
	case 2: _Frame2(); break;
  }

  WidgetMessageQueueClear();
  WidgetPaint(WIDGET_ROOT);
}

int hmi_IndexOfFrame(const char *frame_name)
{
    int i;
    for (i=0; i<g_FrameCount; i++)
       if (strcmp(frame_name, g_FrameNames[i]) == 0) return i+1;
    return 0;
}


void hmi_GotoFrameByName(const char *frame_name)
{
    hmi_GotoFrame(hmi_IndexOfFrame(frame_name));
}

long default_timer_proc(tWidget *pWidget, unsigned long ulMessage,
                     unsigned long ulParam1, unsigned long ulParam2)

{
  ladder_main(1);
  passDataThruBindingOnChange();
  default_output(1);
  return 1;
}

void IOScan_Process(void)
{
  r_out(1);
}


BYTE Polling_Get_Error_State(BYTE en, tHandle mtconn, sMTMaster* mtmdev)
{
  mtmdev->preerrsta = mtmdev->errsta;
  switch (hmi_TCPState(mtconn))
  {
  default:
  case STATE_TCP_IDLE:
    mtmdev->errsta = 1;
    break;
  case STATE_TCP_LISTEN:
    mtmdev->errsta = 1;
    break;
  case STATE_TCP_CONNECTING:
    if(g_ulTickTmrEvtTrig%(500/10) == 0){
    if (mtmdev->preerrsta == 2)
    mtmdev->errsta = 3;
    else if (mtmdev->preerrsta == 3)
    mtmdev->errsta = 2;
    else 
    {
    mtmdev->errsta = 2;
    mtmdev->preerrsta = 2;
    }
    } break;
  case STATE_TCP_CONNECTED:
    if (en > 0)
    mtmdev->errsta = 1;
    else
    mtmdev->errsta = 0;
    break;
    }
  return mtmdev->errsta;
}

static BYTE r_out(BYTE en)
{

  default_input(1);

  return 0;
}

void _frame0()
{
  tContext sContext;
  
  RegisterNullWidgetMsgProc(default_timer_proc);
  
  hmi_grlib_init(HMI_GRLIB_INIT_BASIC);
  GrContextInit(&sContext, HMI_DISPLAY_DRIVER_PTR);
  hmi_GotoFrame(1);
  GrFlush(&sContext);
}
